/******************************************************************************************/
//global variables
/******************************************************************************************/
var svgdoc;
var myDataDisplayTextF;
var seenText;
var LK_Nr;
var koordinatenTextXmin;
var koordinatenTextYmin;
var koordinatenTextXmax;
var koordinatenTextYmax;
var fluss_see;
var lk_info;
var Kanton_Text;
var Help_Text;
var allKantons;

var zoomValueObj;
var allWidth = 380000;
var allHeight = 245000; //check with viewBox of SVG!!! 
var xOriginCorner = 480000; //viewBox="485410 -295935 348428 220650" of main Map ------- new viewBox="480000 -302000 380000 245000"
var yOriginCorner = -302000;

//for pan and zom
var pressed = 0;
var pluginPixWidth;
var pluginPixHeight;
var svgRect;
var svgMainViewport;
var width;
var height;
var evtX;
var evtY;
var rectUlXCorner;
var rectUlYCorner
var scaleFactor;
var myYOffset;

var myClickStatus = 0;
var mapsheetId;
var mapsheetFrame;

// VARIABLES/ ARRAYS  FOR SELeCTION LISTS
var sLselections0   = new Array('1:25 000', '1:50 000' ,'1:100 000');
var lkUrl = new Array('themes/lk25.svg','themes/lk50.svg','themes/lk100.svg');
// when doc. gets loaded, first there wont be any content -> false
var lkLoaded = 'false';
// variable for 'loading...' sign
var loadingData;
//variable to attach topo map group to
var LK;
var LK_Group;

var themeId;		//this var. is used in handleCheckBox(), and delivers the theme id for function doTheme() (ie. relief, canton...) which is to be parsed and added to the main svg
var themeList = new Array ('Hydro','Relief','Kanton');

/******************************************************************************************/
//initializing values
/******************************************************************************************/
function initMap(evt){
	svgdoc = evt.getTarget().getOwnerDocument();
	Kanton_Text = svgDocument.getElementById("Kanton_Text").getFirstChild();
	myDataDisplayTextF = svgDocument.getElementById("dataDisplayTextF").getFirstChild();
	seenText = svgDocument.getElementById("seenText").getFirstChild();
	LK_Nr = svgDocument.getElementById("LK_Nr").getFirstChild();
	koordinatenTextXmin = svgDocument.getElementById("koordinatenTextXmin").getFirstChild();
	koordinatenTextYmin = svgDocument.getElementById("koordinatenTextYmin").getFirstChild();
	koordinatenTextXmax = svgDocument.getElementById("koordinatenTextXmax").getFirstChild();
	koordinatenTextYmax = svgDocument.getElementById("koordinatenTextYmax").getFirstChild();
	fluss_see = svgDocument.getElementById("fluss_see");
	lk_info = svgDocument.getElementById("lk_info");
	Help_Text = svgDocument.getElementById("Help_Text").getFirstChild();
	zoomVal = 100; //initial zoomFactor
	//overviewObjects
	overviewViewport = svgdoc.getElementById("overviewMap");		
	pluginPixWidth = overviewViewport.getAttribute("width");
	pluginPixHeight = overviewViewport.getAttribute("height");
	//reference to draggable rectangle and viewport
	svgRect = svgdoc.getElementById("rectForPlace");
	svgMainViewport = svgdoc.getElementById("MainMap");
	zoomValueObj = svgdoc.getElementById("zoomValueObj");
	zoomValueObj = zoomValueObj.getFirstChild();
	resetFactors(evt);	
	mapsheetFrame = svgDocument.getElementById("mapsheetFrame");
	/*usage: createSelectionList(IndexToStringArray,width,xOffset,yOffset,height(nrOfELements),nrToPreSelect(zero-based!),functionName)
	create an empty group width Id 'selection+indexNr'*/
	sLcreateSelectionList(0,180,500,16,3,0,'selectScale');	// settings for selection list for scale (1:25 000, ...)
	loadingData  =svgdoc.getElementById('loadingData');     // filling variable for 'loading...' sign	
	setTimeout("doScale('0','-')",100);			// sets default topo map (LK) layer: 1:25 000
	loadingData.setAttribute("visibility","visible");
	LK = svgDocument.getElementById('LK');
	for(var i=0; i<themeList.length; i++) {			// starts to put all layers (being selected) into the main svg
		themeId = themeList[i];
		loadingData.setAttribute("visibility","visible");
		var newAddress = 'themes/'+themeId+'.svg';
		getURL(newAddress , parseTheme);
	}	
}

/******************************************************************************************/
//show help texts 
/******************************************************************************************/
function showHelp(evt, text)  {
	if (evt.type == "mouseover"){	
		Help_Text.setData(text); 
	}
	if (evt.type == "mouseout") {
		Help_Text.setData(''); 
	}		
}
/******************************************************************************************/
//checkbox handler script for all layers except the 'lk'- layer
/******************************************************************************************/

function handleCheckBoxClick(evt) {
		var element = evt.getTarget();
		var text = new String(element.id);
		var layerId = text.replace(/CheckBox/,"");
		var layer = svgDocument.getElementById(layerId);
		themeId = layer.getAttribute("id");
		text = "CheckCross"+layerId;
		var crossElement = svgDocument.getElementById(text);
		var currentState = crossElement.getAttribute("visibility");
		//currentTheme = layer;
		if (currentState == "hidden") {
			newState = "visible";
			setTimeout("doTheme()",200);	// is is calling the function doTheme(), the var. themeId (=layerId) is global, 
		} else {				// set in this funtion but will be use in doTheme() again. wasnt able to deliver var. themeId with the doTheme() ??? I dont know why...
			newState = "hidden";
			//removeTheme(layer);
			setTimeout("unDoTheme()",200);
		}
		crossElement.setAttribute("visibility", newState);
		loadingData.setAttribute("visibility","visible");
}

/******************************************************************************************/
//checkbox handler for the LK- layer seperatly, it switches on/ off the legend and the layer!
/******************************************************************************************/
var lkState = 'visible';
function handleCheckBoxClickLK(evt) {
 		var element = evt.getTarget();
		var text = new String(element.id);
		var layerId = text.replace(/CheckBox/,"");
		var layer = svgDocument.getElementById(layerId);
		themeId = layer.getAttribute("id");
		text = "CheckCross"+layerId;
		var crossElement = svgDocument.getElementById(text);
		var currentState = crossElement.getAttribute("visibility");
		if (currentState == "hidden") {
			newState = "visible";
			//getURL(lkUrl[scaleChoice], parseLK);
			setTimeout("doScale("+scaleChoice+",'-')",200);
		} else {
			newState = "hidden";
			//removeTheme(layer);
			setTimeout("unDoTheme()",200);
		}
		crossElement.setAttribute("visibility", newState);
		lk_info.setAttribute("visibility", newState);
		lkState = newState;
		loadingData.setAttribute("visibility","visible");
}
/******************************************************************************************/
//shows the attributes of the 'kanton' layer object
/******************************************************************************************/
function showAttribData(evt,layer,objectId) {	
	//it gets the Element of the target object
	var myElObj = svgDocument.getElementById(layer+objectId);
	myString = eval(layer+objectId)[2];
		if (evt.type == "mouseover") {
			if (!myString) {
				myString = "-";
			}	
			allKantons = svgDocument.getElementById('kanton'+myString);
			Kanton_Text.setData(myString);	
			allKantons.setAttribute('fill', '#F0F8FF');
			allKantons.setAttribute('fill-opacity', '.8');
		}
    if (evt.type == "mouseout") {
			//removes the data
			allKantons = svgDocument.getElementById('kanton'+myString);
			Kanton_Text.setData("-");
			allKantons.setAttribute('fill', 'rgb(255, 239, 213)');
			allKantons.setAttribute('fill-opacity', '.7');	
     }
}
/******************************************************************************************/
//shows attributes of the 'fluss' layers objects
/******************************************************************************************/
function showAttribDataF(evt,layer,objectId) {
	if (evt.type == "mouseover") {
			myElement = layer+objectId;
			myString = eval(myElement)[0];
			if (!myString) {
				myString = "-";
			}	
			myDataDisplayTextF.setData(myString);		
		}
		if (evt.type == "mouseout") {
			myDataDisplayTextF.setData("-");
		}	
}
/******************************************************************************************/
//shows attributes of the 'see' layer objects
/******************************************************************************************/
function showSeenDataF(evt,seenId) {
	if (evt.type == "mouseover") {
			myElement = "seen"+seenId;
			myString = eval(myElement)[0];
			if (!myString) {
				myString = "-";
			}	
			seenText.setData(myString);		
		}
		if (evt.type == "mouseout") {
			seenText.setData("-");
		}	
}
/******************************************************************************************/
//shows Attributes of LK25 and highlight the current LK25- sheet
/******************************************************************************************/
var lkLabel = svgDocument.getElementById('lkLabel');

function showAttribDataLK(evt,LK,LKId) {		//eg. 	LK ='lk25'; LKId = '1320'
	var myElObj = svgDocument.getElementById('lk' + LKId);
	myString = eval('lk'+LKId);		
	myRect = myElObj.getBBox();
		if (evt.type == "mouseover") {
			LK_Nr.setData(myString[0] +', '+ LKId);
			myElObj.setAttribute('fill', 'rgb(255, 20, 30)');
			myElObj.setAttribute('fill-opacity', '.7');			
			// to display coordinates (x,y min and max) of topo map in GUI
			koordinatenTextXmin.setData("X- Min:  "+(myRect.x));
			koordinatenTextYmin.setData("Y- Min:  "+((myRect.y+myRect.height)*-1));   //+(myRect.y*(-1))
			koordinatenTextXmax.setData("X- Max: "+(myRect.x+myRect.width));
			koordinatenTextYmax.setData("Y- Max: "+(myRect.y*(-1)));    //+((myRect.y+myRect.height)*-1)
			//Help_Text.setData('x: '+myRect.x+', y: '+myRect.y+', width: '+myRect.width+', height: '+myRect.height);			
			//variables for label-style
			var labelSize, labelOpacity, labelXFact, labelYFact;
			lkString = new String(LKId);	// converts LKId into a string
			//filling variables for label-style
			if (lkString.length == 4) {
				labelSize = '7000';
				labelOpacity = '1';
				labelXFact = 0.45;
				labelYFact= 0.5;
			}
			if (lkString.length == 3) {
				labelSize = '15000';
				labelOpacity = '.7';
				labelXFact = 0.4;
				labelYFact = 0.5;
			}
			if (lkString.length == 2) {
				labelSize = '20000';
				labelOpacity = '.7';
				labelXFact = 0.18;
				labelYFact = 0.33;
			}
			// to label bounding box of topo map / LK
			lkLabel.setAttribute('x',myRect.x+(myRect.width*labelXFact));
			lkLabel.setAttribute('y',myRect.y+(myRect.height*labelYFact));
			lkLabel.setAttribute('style','fill:white;fill-opacity:'+labelOpacity+';font-size:'+labelSize+';pointer-events:none;text-anchor:middle;font-family:Helvetica, Arial;');
			lkLabel.getFirstChild().setData(LKId);			
			Help_Text.setData('Click to start download of map sheet '+ myString[0] +', '+ LKId +'.'); 
	 	}
		if (evt.type == "mouseout") {
			myElObj.setAttribute('fill', 'rgb(150,150,150)');
			myElObj.setAttribute('fill-opacity', '.1');
			lkLabel.getFirstChild().setData(' ');
			if (myClickStatus == 0){
				LK_Nr.setData("-");
				koordinatenTextXmin.setData("-");
				koordinatenTextYmin.setData("-");
				koordinatenTextXmax.setData("-");
				koordinatenTextYmax.setData("-");
			}
			Help_Text.setData(''); 
		}		
}
/******************************************************************************************/
// reset factors 
/******************************************************************************************/
function resetFactors(evt) {
	myRatio = 1024/768;
	if ((window.innerWidth/window.innerHeight) > myRatio) {
		scaleFactor = 768 / window.innerHeight;
	}
	else {
		scaleFactor = 1024 / window.innerWidth;		
	}
}
/******************************************************************************************/
//magnifier glass mouse-over effects
/******************************************************************************************/
function magnify(evt,scaleFact,inOrOut) {
	if (inOrOut == "in") {
		if (zoomVal < 1000) {
			//statusChange("click to zoom in");
			Help_Text.setData('Click on Button to zoom in.'); 
			scaleObject(evt,scaleFact);
		}
		else {
			//statusChange("maximum zoom factor reached! cannot zoom in any more!");
			Help_Text.setData('Maximum Zoom  Level is reached.'); 			
		}
	}
	if (inOrOut == "out") {
		if (zoomVal > 100) {
			//statusChange("click to zoom out");
			Help_Text.setData('Click on Button zoom out.'); 
			scaleObject(evt,scaleFact);
		}
		else {
		//	statusChange("minimum zoom factor reached! cannot zoom out any more!");	
			Help_Text.setData('Minimum Zoom  Level is reached.'); 		
		}		
	}
	if (inOrOut == "full") {
		if (zoomVal != 100) {
			Help_Text.setData('Click on Button for full Display.'); 
			//scaleObject(evt,scaleFact);
		} else {
			Help_Text.setData('Minimum Zoom  Level is reached...'); 
		}
	}
	
	if (scaleFact == 1) {
			//statusChange("map ready");	
			Help_Text.setData('Map is ready!'); 	
			scaleObject(evt,scaleFact);
	}	
}
/******************************************************************************************/
//scale any object that has a transform-value
/******************************************************************************************/
function scaleObject(evt,factor) {
        //reference to the currently selected object
        var element = evt.getTarget();
        //query old transform value (we need the translation value)
        var curTransform = element.getAttribute("transform");
        curTransform = new String(curTransform); //Wert in einen String umwandeln
        //no fear from Regular expressions ... just copy it, I copied it either ...
        var translateRegExp=/translate\(([-+]?\d+)(\s*[\s,]\s*)([-+]?\d+)\)\s*/;
        //This part extracts the translation-value from the whole transform-string
        if (curTransform.length != 0)
        {
          var result = curTransform.match(translateRegExp);
          if (result == null || result.index == -1)
          {
             oldTranslateX = 0;
             oldTranslateY = 0;
          }
          else
          {
             oldTranslateX = result[1];
             oldTranslateY = result[3];
          }
          var newtransform = "translate(" + oldTranslateX + " " + oldTranslateY + ") " + "scale(" + factor + ")";	 //concatenate the string again, add scale-factor
        }
        element.setAttribute('transform', newtransform);		 //set transform-factor
}

/******************************************************************************************/
function beginPan(evt) {
	pressed = 1;
	width = parseFloat(svgRect.getAttribute("width"));
	height = parseFloat(svgRect.getAttribute("height"));
	evtX = parseFloat(evt.getClientX()) * scaleFactor;
	evtY = parseFloat(evt.getClientY()) * scaleFactor;
	rectUlXCorner = parseFloat(svgRect.getAttribute("x"));
	rectUlYCorner = parseFloat(svgRect.getAttribute("y"));	
}
/******************************************************************************************/
function doPan(evt) {
	if (pressed == 1) {
		newEvtX = parseFloat(evt.getClientX()) * scaleFactor; //scaleFactor is because of resizable interface
		newEvtY = parseFloat(evt.getClientY()) * scaleFactor;
		toMoveX = rectUlXCorner + (newEvtX - evtX) * allWidth / pluginPixWidth;
		toMoveY = rectUlYCorner + (newEvtY - evtY) * allHeight / pluginPixHeight;		
		//restrict to borders of overviewmap
		if (toMoveX < xOriginCorner) {
			svgRect.setAttribute("x",xOriginCorner);
		}
		else if ((toMoveX + width) > (xOriginCorner + allWidth)) {
			svgRect.setAttribute("x",xOriginCorner + allWidth - width);				
		}
		else {
			svgRect.setAttribute("x",toMoveX);			
		}
		if (toMoveY < yOriginCorner) {
			svgRect.setAttribute("y",yOriginCorner);
		}
		else if ((toMoveY + height) > (yOriginCorner + allHeight)) {
			svgRect.setAttribute("y",yOriginCorner + allHeight - height);
		}				
		else {
			svgRect.setAttribute("y",toMoveY);
		}
		
		evtX = newEvtX;
		evtY = newEvtY;
		rectUlXCorner = parseFloat(svgRect.getAttribute("x"));
		rectUlYCorner = parseFloat(svgRect.getAttribute("y"));	
	}	
}
/******************************************************************************************/
function endPan() {
	//statusChange("panning map - please be patient ...");
	Help_Text.setData('Please be patient!'); 
	pressed = 0;
	//set viewport of main map
	xulcorner = parseFloat(svgRect.getAttribute("x"));
	yulcorner = parseFloat(svgRect.getAttribute("y"));
	width = parseFloat(svgRect.getAttribute("width"));
	height = parseFloat(svgRect.getAttribute("height"));
	newViewport = xulcorner + " " + yulcorner + " " + width + " " + height;
	svgMainViewport.setAttribute("viewBox",newViewport);
	//statusChange("map ready ...");
	Help_Text.setData('Map is ready!'); 
}

/******************************************************************************************/
function zoomIt(inOrOut) {
	if (inOrOut == "in") {
		if (zoomVal < 1000) {
			Help_Text.setData('Click on Button to zoom in.'); 
			zoomVal = zoomVal + 100;
			zoomItReally();
		}
		else {
			Help_Text.setData('Maximum Zoom Level is reached.'); 
		}
	}
	if (inOrOut == "out") {
		if (zoomVal > 100) {
			Help_Text.setData('Click on Button zoom out.'); 
			zoomVal = zoomVal - 100;
			zoomItReally();
		}
		else {
			Help_Text.setData('Minimum Zoom Level is reached.'); 
		}		
	}
	if (inOrOut == "full") {
		Help_Text.setData('Click on Button for full Display.'); 
		zoomVal = 100;
		zoomItReally();
		/*if (zoomVal =! 100) {
			//Help_Text.setData(zoomVal); 
			Help_Text.setData('Click on Button zoom out.'); 
			zoomVal = 100;
			zoomItReally();
		}
		else {
			Help_Text.setData('Minimum Zoom Level is reached.'); 
		}	*/	
	}
}
/******************************************************************************************/
function zoomItReally() {
	Help_Text.setData('Please be patient!'); 
	xulcorner = parseFloat(svgRect.getAttribute("x"));	//get values from draggable rectangle
	yulcorner = parseFloat(svgRect.getAttribute("y"));
	width = parseFloat(svgRect.getAttribute("width"));
	height = parseFloat(svgRect.getAttribute("height"));	
	xcenter = xulcorner + width / 2;			//calcs
	ycenter = yulcorner + height / 2;
	xnulcorner = xcenter - allWidth / 2 * (100/zoomVal);
	ynulcorner = ycenter - allHeight / 2 * (100/zoomVal);
	nWidth = allWidth * (100/zoomVal);
	nHeight = allHeight * (100/zoomVal);
	if (zoomVal == 100) {
		xnulcorner = xOriginCorner;
		ynulcorner = yOriginCorner;
	}		
	svgRect.setAttribute("x",xnulcorner);			//set values of draggable rectangle
	svgRect.setAttribute("y",ynulcorner);
	svgRect.setAttribute("width",nWidth);
	svgRect.setAttribute("height",nHeight);	
	newViewport = xnulcorner + " " + ynulcorner + " " + nWidth + " " + nHeight;	//set viewport of main map
	svgMainViewport.setAttribute("viewBox",newViewport);
	zoomValueObj.setData(zoomVal+'%');
	Help_Text.setData('Map is ready!'); 
}
/******************** STARTS TO DOWNLOAD MAP SHEET*******************/
function showMapsheet(evt){
	myClickStatus = 1;
	var mapsheet = evt.getTarget();
	var mapsheetId = mapsheet.getAttribute('id');	
	//distinguish b/w lk25, lk50 and lk100
	if (mapsheetId.length == 6) {			//lk25
		var mapsheetNr = mapsheetId.replace(/lk/,"");
		parent.window.open("../mapbrowser/mapsheets/"+mapsheetNr+".jpg", "Kartenblatt"+mapsheetNr, "width=500,height=365,left=100,top=200");
		//parent.window.open("//Karto/ides/PK25_Q3_2003/komb_10/"+mapsheetNr+".tif", "_self");		//address change!!!
		//alert("You chose the map sheet Nr"+mapsheetNr+"!");
	}
	if (mapsheetId.length == 5) {			//lk50
		var mapsheetNr = mapsheetId.replace(/lk/,"");
		//parent.window.open("//Karto/ides/PK50_Q3_2003/krel_10/"+mapsheetNr+".tif", "_self");		//address change!!!
		alert("You chose the map sheet Nr "+mapsheetNr+"! This map is not implemented yet!");
	}
	if (mapsheetId.length == 4) {			//lk100
		var mapsheetNr = mapsheetId.replace(/lk/,"");
		//parent.window.open("//Karto/ides/PK100_Q3_2003/krel_10/"+mapsheetNr+".tif", "_self");		//address change!!!
		alert("You chose the map sheet Nr "+mapsheetNr+"! This map is not implemented yet!");
	}
	myClickStatus = 0;
}
/**************************** SELECTING SCALE *************************/
var scaleChoice = 0;
function selectScale(indexNr,listNr) {
	//alert('you clicked Nr. '+(indexNr)+', value: '+eval('sLselections'+listNr)[indexNr]);
	loadingData.setAttribute("visibility","visible");
	scaleChoice = indexNr;
	setTimeout("doScale("+indexNr+","+listNr+")",200);
}
/****************************** DO SCALE ******************************/
function doScale(indexNr,listNr) {
	getURL(lkUrl[indexNr], parseLK);
}
/*************************** PARSE LK-LAYER ***************************/	
function parseLK(data) {
	if (lkState == 'visible') {	//askes if layer/theme is on at all, if not it returns
		if(data.success) {
			if (lkLoaded == 'true') {	//checkes if there are any data loaded at all
				var lkSVG = svgdoc.getElementById('LK_SVG');    // group in the svg-fragment
				LK.removeChild(lkSVG);
				lastObject = null;
		   	}
		   	var node = parseXML(data.content, svgdoc);
		   	//alert(node);
			LK.appendChild(node);
			lkLoaded = 'true';  
		}
		else {
			alert('something went wrong');
		}
	} 
	loadingData.setAttribute("visibility","hidden");
}
/****************************** DO THEME ******************************/
function doTheme() {
	var newAddress = 'themes/'+themeId+'.svg';
	getURL(newAddress, parseTheme);
}
/*************************** PARSES THEMES-LAYER **********************/
function parseTheme(data) {
	var currentTheme = svgdoc.getElementById(themeId);
	if(data.success){
		var stringOfDataContent = data.content;
		var node = parseXML(data.content, svgdoc);
		stringOfDataContent= stringOfDataContent.split("\"");
		stringOfDataContent = stringOfDataContent[1].replace(/_SVG/, '');
		var currentTheme = svgdoc.getElementById(stringOfDataContent);
		currentTheme.appendChild(node);
		//alert(stringOfDataContent);
		//alert(substring-after(stringOfDataContent,'id='));
		
		}
	else {
		alert(currentTheme+': something went wrong');
	}
	loadingData.setAttribute("visibility","hidden");	
	
}
/****************************** UN DO THEME **************************/
function unDoTheme() {
	removeTheme(themeId);
}
/*************************** REMOVES THEMES-LAYER ********************/
function removeTheme(themeId) {
	var currThemeId = new String (themeId);
	var currentTheme = svgdoc.getElementById(themeId);	//currentTheme ... the theme from which a child layer will be removed 
	currChildThemeId = currThemeId+'_SVG';			//creates ID of the child layer which is to be removed -> this groupd will be removed
	var childTheme = svgdoc.getElementById(currChildThemeId);
	/*removes child layer, we need surounding group to add/ attach child group later to it
	the id is given in 'Kanton.svg' document for instance*/
	//alert(childTheme.id);
	currentTheme.removeChild(childTheme);
	if (themeId == 'LK') {					// we have to make this distingh. (how to u spell this?) because in the 
		lkLoaded = 'false';  				// parseLK-function the status is needed
	}
	loadingData.setAttribute("visibility","hidden");
}